(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/operators'), require('@angular/router'), require('@angular/common'), require('@angular/material/paginator'), require('@angular/material/sort'), require('@angular/animations'), require('@angular/material/toolbar'), require('@angular/material/icon'), require('@angular/material/button'), require('@angular/material/table'), require('@angular/material/card'), require('@angular/material/form-field')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-base-angular-layout', ['exports', '@angular/core', 'rxjs/operators', '@angular/router', '@angular/common', '@angular/material/paginator', '@angular/material/sort', '@angular/animations', '@angular/material/toolbar', '@angular/material/icon', '@angular/material/button', '@angular/material/table', '@angular/material/card', '@angular/material/form-field'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-base-angular-layout'] = {}), global.ng.core, global.rxjs.operators, global.ng.router, global.ng.common, global.ng.material.paginator, global.ng.material.sort, global.ng.animations, global.ng.material.toolbar, global.ng.material.icon, global.ng.material.button, global.ng.material.table, global.ng.material.card, global.ng.material['form-field']));
}(this, (function (exports, core, operators, router, common, paginator, sort, animations, toolbar, icon, button, table, card, formField) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LayoutComponent = /** @class */ (function () {
        function LayoutComponent() {
        }
        /**
         * @return {?}
         */
        LayoutComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        LayoutComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-layout',
                        template: "\n    <p>\n      layout works!\n    </p>\n  "
                    }] }
        ];
        /** @nocollapse */
        LayoutComponent.ctorParameters = function () { return []; };
        return LayoutComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function RowColumn() { }
    if (false) {
        /** @type {?} */
        RowColumn.prototype.columnId;
        /** @type {?} */
        RowColumn.prototype.columnName;
    }
    var TableRowColumnDirective = /** @class */ (function () {
        function TableRowColumnDirective(templateRef) {
            this.templateRef = templateRef;
        }
        TableRowColumnDirective.decorators = [
            { type: core.Directive, args: [{ selector: 'ng-template[rowColumn]' },] }
        ];
        /** @nocollapse */
        TableRowColumnDirective.ctorParameters = function () { return [
            { type: core.TemplateRef }
        ]; };
        TableRowColumnDirective.propDecorators = {
            rowColumn: [{ type: core.Input }]
        };
        return TableRowColumnDirective;
    }());
    if (false) {
        /** @type {?} */
        TableRowColumnDirective.prototype.rowColumn;
        /** @type {?} */
        TableRowColumnDirective.prototype.templateRef;
    }
    var TableContentComponent = /** @class */ (function () {
        function TableContentComponent(router, activatedRoute, location) {
            this.router = router;
            this.activatedRoute = activatedRoute;
            this.location = location;
            this.hasToolbar = true;
            this.hasSearch = true;
            this.hasAddButton = true;
            this.hasBackButton = true;
            this.hasPaginator = true;
            this.tableRowClick = new core.EventEmitter();
        }
        Object.defineProperty(TableContentComponent.prototype, "tableLayoutInput", {
            get: /**
             * @return {?}
             */
            function () {
                return this._tableLayoutInput;
            },
            set: /**
             * @param {?} tl
             * @return {?}
             */
            function (tl) {
                this._tableLayoutInput = tl;
            },
            enumerable: true,
            configurable: true
        });
        ;
        Object.defineProperty(TableContentComponent.prototype, "matSort", {
            set: /**
             * @param {?} ms
             * @return {?}
             */
            function (ms) {
                this.sort = ms;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableContentComponent.prototype, "matPaginator", {
            set: /**
             * @param {?} ms
             * @return {?}
             */
            function (ms) {
                this.paginator = ms;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TableContentComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.dataSource = this.tableLayoutInput.dataSource;
            this.dataSource.setPaginator(this.paginator);
            this.dataSource.setSort(this.sort);
            this.tableLayoutInput.columnDef.pipe(operators.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.columnId; })); }))).subscribe((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                _this.displayedColumns = res;
            }));
            this.tableLayoutInput.columnDef.pipe(operators.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.columnName; })); }))).subscribe((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                _this.columnNames = res;
            }));
            if (this.tableLayoutInput.addRoute) {
                this.addRoute = this.tableLayoutInput.addRoute;
            }
            if (this.tableLayoutInput.backRoute) {
                this.backRoute = this.tableLayoutInput.backRoute;
            }
        };
        /**
         * @return {?}
         */
        TableContentComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var columnMap = new Map();
            /** @type {?} */
            var refArray = this.rowColumnDirectives.toArray();
            refArray.forEach((/**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                columnMap.set(val.rowColumn, val);
            }));
            this.rowColumnTemplates = columnMap;
        };
        /**
         * @return {?}
         */
        TableContentComponent.prototype.getPageSizeOptions = /**
         * @return {?}
         */
        function () {
            return [5, 10, 20, 50, 100, 250];
        };
        /**
         * @return {?}
         */
        TableContentComponent.prototype.getDefaultPageSize = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var tableFilter = this.dataSource.filterSubject.value;
            if (tableFilter && tableFilter.pager) {
                return tableFilter.pager.pageSize;
            }
            return 250;
        };
        /**
         * @return {?}
         */
        TableContentComponent.prototype.add = /**
         * @return {?}
         */
        function () {
            if (this.addRoute) {
                if (this.addRoute.queryParams) {
                    this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
                }
                else {
                    this.router.navigate([this.addRoute.path]);
                }
            }
            else {
                this.router.navigate(['0'], { relativeTo: this.activatedRoute });
            }
        };
        /**
         * @return {?}
         */
        TableContentComponent.prototype.back = /**
         * @return {?}
         */
        function () {
            if (this.backRoute) {
                if (this.backRoute.queryParams) {
                    this.router.navigate([this.backRoute.path], { queryParams: this.backRoute.queryParams });
                }
                else {
                    this.router.navigate([this.backRoute.path]);
                }
            }
            else {
                this.location.back();
            }
        };
        /**
         * @param {?} row
         * @return {?}
         */
        TableContentComponent.prototype.onRowClick = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            this.tableRowClick.emit(row);
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        TableContentComponent.prototype.reload = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            filter = __assign({}, this.dataSource.filterSubject.value, filter);
            this.dataSource.filterSubject.next(filter);
            return false;
        };
        /**
         * @return {?}
         */
        TableContentComponent.prototype.navigateBack = /**
         * @return {?}
         */
        function () {
            this.location.back();
        };
        TableContentComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-table-content',
                        template: "<mat-toolbar *ngIf=\"tableLayoutInput.title\" color=\"accent\" style=\"height:20px; opacity: 0.5\"><span\n  style=\"font-size: 0.7em\">{{tableLayoutInput?.title}}</span></mat-toolbar>\n<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" (click)='back()' class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n  <ng-container>   <!-- <ng-container *permissionEdit=\"tableLayoutInput.expectedRoles\">-->\n    <button *ngIf=\"!tableLayoutInput.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix this -->\n<!--  <button *ngIf=\"tableLayoutInput.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n          (click)=\"dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n    <mat-icon>cloud_download</mat-icon>\n  </button>-->\n\n<!--  <table-search [searchFields]=\"tableLayoutInput.advanceSearchCriteria\"\n                [hasAdvanceSearch]=\"tableLayoutInput.advanceSearch\" *ngIf=\"tableLayoutInput.searchable && hasSearch\"\n                (changed)=\"reload($event)\"\n                class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<table #matTable mat-table [dataSource]=\"dataSource\" matSort\n       matSortActive=\"{{tableLayoutInput.matSortActive}}\" matSortDisableClear\n       matSortDirection=\"{{tableLayoutInput.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\">\n\n  <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n    <th mat-sort-header mat-header-cell *matHeaderCellDef>\n      {{columnNames[i]}}\n    </th>\n    <td mat-cell *matCellDef=\"let row\">\n      <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                    [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n    </td>\n  </ng-container>\n\n  <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n  <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\" class=\"row-click\"></tr>\n</table>\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"dataSource.status == 'loading'\" fxLayoutAlign=\"center\">\n  <!-- TODO extract loading indicator component to library <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n<!-- ===================================== Table empty ============================================================= -->\n<mat-card *ngIf=\"dataSource?.dataSubject?.value?.length === 0\" fxLayoutAlign=\"center\">\n  <span><!-- TODO should be configured as input prop -->Die Tabelle hat noch keine Eintr\u00E4ge!</span>\n</mat-card>\n\n<!-- ===================================== Table error ============================================================= -->\n<mat-card *ngIf=\"dataSource?.status === 'error'\" fxLayoutAlign=\"center\">\n  <mat-error><!-- TODO should be configured as input prop --> Es ist etwas falsch gelaufen</mat-error>\n</mat-card>\n"
                    }] }
        ];
        /** @nocollapse */
        TableContentComponent.ctorParameters = function () { return [
            { type: router.Router },
            { type: router.ActivatedRoute },
            { type: common.Location }
        ]; };
        TableContentComponent.propDecorators = {
            tableLayoutInput: [{ type: core.Input }],
            rowColumnDirectives: [{ type: core.ContentChildren, args: [TableRowColumnDirective,] }],
            hasToolbar: [{ type: core.Input }],
            hasSearch: [{ type: core.Input }],
            hasAddButton: [{ type: core.Input }],
            hasBackButton: [{ type: core.Input }],
            hasPaginator: [{ type: core.Input }],
            tableRowClick: [{ type: core.Output }],
            matSort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }],
            matPaginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }]
        };
        return TableContentComponent;
    }());
    if (false) {
        /** @type {?} */
        TableContentComponent.prototype._tableLayoutInput;
        /** @type {?} */
        TableContentComponent.prototype.dataSource;
        /** @type {?} */
        TableContentComponent.prototype.rowColumnDirectives;
        /** @type {?} */
        TableContentComponent.prototype.rowColumnTemplates;
        /** @type {?} */
        TableContentComponent.prototype.hasToolbar;
        /** @type {?} */
        TableContentComponent.prototype.hasSearch;
        /** @type {?} */
        TableContentComponent.prototype.hasAddButton;
        /** @type {?} */
        TableContentComponent.prototype.hasBackButton;
        /** @type {?} */
        TableContentComponent.prototype.hasPaginator;
        /** @type {?} */
        TableContentComponent.prototype.tableRowClick;
        /** @type {?} */
        TableContentComponent.prototype.addRoute;
        /** @type {?} */
        TableContentComponent.prototype.backRoute;
        /**
         * @type {?}
         * @private
         */
        TableContentComponent.prototype.paginator;
        /**
         * @type {?}
         * @private
         */
        TableContentComponent.prototype.sort;
        /** @type {?} */
        TableContentComponent.prototype.displayedColumns;
        /** @type {?} */
        TableContentComponent.prototype.columnNames;
        /**
         * @type {?}
         * @private
         */
        TableContentComponent.prototype.router;
        /**
         * @type {?}
         * @private
         */
        TableContentComponent.prototype.activatedRoute;
        /**
         * @type {?}
         * @private
         */
        TableContentComponent.prototype.location;
        /* Skipping unhandled member: ;*/
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TableTitleComponent = /** @class */ (function () {
        function TableTitleComponent() {
        }
        /**
         * @return {?}
         */
        TableTitleComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        TableTitleComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'app-table-title',
                        template: "<p>\n  table-title works!\n</p>\n"
                    }] }
        ];
        /** @nocollapse */
        TableTitleComponent.ctorParameters = function () { return []; };
        return TableTitleComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TableHeaderComponent = /** @class */ (function () {
        function TableHeaderComponent() {
        }
        /**
         * @return {?}
         */
        TableHeaderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        TableHeaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-table-header',
                        template: "<mat-toolbar fxLayoutGap=\"10px\">\n  <ng-content></ng-content>\n  <div class=\"spacer\"></div>\n</mat-toolbar>\n"
                    }] }
        ];
        /** @nocollapse */
        TableHeaderComponent.ctorParameters = function () { return []; };
        return TableHeaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TableLayoutComponent = /** @class */ (function () {
        function TableLayoutComponent() {
            this.status = 'loading';
        }
        /**
         * @return {?}
         */
        TableLayoutComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        TableLayoutComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-table-layout',
                        template: "<div class=\"table-layout mat-elevation-z12\">\n  <ng-content select=\"[content]\"></ng-content>\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        TableLayoutComponent.ctorParameters = function () { return []; };
        TableLayoutComponent.propDecorators = {
            status: [{ type: core.Input }]
        };
        return TableLayoutComponent;
    }());
    if (false) {
        /** @type {?} */
        TableLayoutComponent.prototype.status;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function RowColumn$1() { }
    if (false) {
        /** @type {?} */
        RowColumn$1.prototype.columnId;
        /** @type {?} */
        RowColumn$1.prototype.columnName;
    }
    var TableContentResponsiveComponent = /** @class */ (function () {
        function TableContentResponsiveComponent(router, activatedRoute, location) {
            this.router = router;
            this.activatedRoute = activatedRoute;
            this.location = location;
            this.hasToolbar = true;
            this.hasSearch = true;
            this.hasAddButton = true;
            this.hasBackButton = true;
            this.hasPaginator = true;
            this.tableRowClick = new core.EventEmitter();
        }
        Object.defineProperty(TableContentResponsiveComponent.prototype, "tableLayoutInput", {
            get: /**
             * @return {?}
             */
            function () {
                return this._tableLayoutInput;
            },
            set: /**
             * @param {?} tl
             * @return {?}
             */
            function (tl) {
                this._tableLayoutInput = tl;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableContentResponsiveComponent.prototype, "matSort", {
            set: /**
             * @param {?} ms
             * @return {?}
             */
            function (ms) {
                this.sort = ms;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableContentResponsiveComponent.prototype, "matPaginator", {
            set: /**
             * @param {?} ms
             * @return {?}
             */
            function (ms) {
                this.paginator = ms;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.tableLayoutInput.dataSource.setPaginator(this.paginator);
            this.tableLayoutInput.dataSource.setSort(this.sort);
            this.tableLayoutInput.columnDef.pipe(operators.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.columnId; })); }))).subscribe((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                _this.displayedColumns = res;
            }));
            this.tableLayoutInput.columnDef.pipe(operators.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.columnName; })); }))).subscribe((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                _this.columnNames = res;
            }));
            if (this.tableLayoutInput.addRoute) {
                this.addRoute = this.tableLayoutInput.addRoute;
            }
        };
        /**
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var columnMap = new Map();
            /** @type {?} */
            var refArray = this.rowColumnDirectives.toArray();
            refArray.forEach((/**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                columnMap.set(val.rowColumn, val);
            }));
            this.rowColumnTemplates = columnMap;
        };
        /**
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.getPageSizeOptions = /**
         * @return {?}
         */
        function () {
            return [5, 10, 20, 50, 100, 250];
        };
        /**
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.getDefaultPageSize = /**
         * @return {?}
         */
        function () {
            return 250;
        };
        /**
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.add = /**
         * @return {?}
         */
        function () {
            if (this.addRoute) {
                if (this.addRoute.queryParams) {
                    this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
                }
                else {
                    this.router.navigate([this.addRoute.path]);
                }
            }
            else {
                this.router.navigate(['0'], { relativeTo: this.activatedRoute });
            }
        };
        /**
         * @param {?} row
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.onRowClick = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            this.tableRowClick.emit(row);
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.reload = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            this.tableLayoutInput.dataSource.filterSubject.next(filter);
            return false;
        };
        /**
         * @return {?}
         */
        TableContentResponsiveComponent.prototype.navigateBack = /**
         * @return {?}
         */
        function () {
            this.location.back();
        };
        TableContentResponsiveComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-table-content-responsive',
                        template: "<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" [routerLink]=\"'..'\" class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n  <ng-container><!-- <ng-container *permissionEdit=\"tableLayoutInput.expectedRoles\">-->\n    <button *ngIf=\"!tableLayoutInput.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix the excel export; probably those controls should be injectable via template/ngcontent -->\n<!--  <button *ngIf=\"tableLayoutInput.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n          (click)=\"tableLayoutInput.dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n    <mat-icon>cloud_download</mat-icon>\n  </button>-->\n\n<!--  <table-search [searchFields]=\"tableLayoutInput.advanceSearchCriteria\"\n                [hasAdvanceSearch]=\"tableLayoutInput.advanceSearch\" *ngIf=\"tableLayoutInput.searchable && hasSearch\"\n                (changed)=\"reload($event)\"\n                class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"getDefaultPageSize()\" [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<div class=\"base-table-responsive\">\n  <mat-table multiTemplateDataRows [dataSource]=\"tableLayoutInput.dataSource\" matSort\n             matSortActive=\"{{tableLayoutInput.matSortActive}}\" matSortDisableClear\n             matSortDirection=\"{{tableLayoutInput.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\"\n             class=\"expandable\">\n\n    <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n\n      <mat-header-cell *matHeaderCellDef mat-sort-header>\n        {{columnNames[i]}}\n      </mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span class=\"resp-row-label\" style=\"float:left; padding:0;\">{{columnNames[i]}}</span>\n        <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                      [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n      </mat-cell>\n\n    </ng-container>\n\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\">\n    </mat-row>\n\n  </mat-table>\n</div>\n\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"tableLayoutInput.dataSource.status == 'loading'\" fxLayoutAlign=\"center\">\n<!-- TODO put loading indicator here  <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n\n\n",
                        animations: [
                            animations.trigger('detailExpand', [
                                animations.state('collapsed', animations.style({ height: '0px', minHeight: '0', display: 'none' })),
                                animations.state('expanded', animations.style({ height: '*' })),
                                animations.transition('expanded <=> collapsed', animations.animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                            ]),
                        ]
                    }] }
        ];
        /** @nocollapse */
        TableContentResponsiveComponent.ctorParameters = function () { return [
            { type: router.Router },
            { type: router.ActivatedRoute },
            { type: common.Location }
        ]; };
        TableContentResponsiveComponent.propDecorators = {
            tableLayoutInput: [{ type: core.Input }],
            rowColumnDirectives: [{ type: core.ContentChildren, args: [TableRowColumnDirective,] }],
            hasToolbar: [{ type: core.Input }],
            hasSearch: [{ type: core.Input }],
            hasAddButton: [{ type: core.Input }],
            hasBackButton: [{ type: core.Input }],
            hasPaginator: [{ type: core.Input }],
            tableRowClick: [{ type: core.Output }],
            matSort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }],
            matPaginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }]
        };
        return TableContentResponsiveComponent;
    }());
    if (false) {
        /** @type {?} */
        TableContentResponsiveComponent.prototype._tableLayoutInput;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.expandedElement;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.rowColumnDirectives;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.rowColumnTemplates;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.hasToolbar;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.hasSearch;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.hasAddButton;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.hasBackButton;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.hasPaginator;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.tableRowClick;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.addRoute;
        /**
         * @type {?}
         * @private
         */
        TableContentResponsiveComponent.prototype.paginator;
        /**
         * @type {?}
         * @private
         */
        TableContentResponsiveComponent.prototype.sort;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.displayedColumns;
        /** @type {?} */
        TableContentResponsiveComponent.prototype.columnNames;
        /**
         * @type {?}
         * @private
         */
        TableContentResponsiveComponent.prototype.router;
        /**
         * @type {?}
         * @private
         */
        TableContentResponsiveComponent.prototype.activatedRoute;
        /**
         * @type {?}
         * @private
         */
        TableContentResponsiveComponent.prototype.location;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TableLayoutModule = /** @class */ (function () {
        function TableLayoutModule() {
        }
        TableLayoutModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            TableRowColumnDirective,
                            TableContentComponent,
                            TableTitleComponent,
                            TableHeaderComponent,
                            TableLayoutComponent,
                            TableContentResponsiveComponent
                        ],
                        imports: [
                            toolbar.MatToolbarModule,
                            icon.MatIconModule,
                            button.MatButtonModule,
                            common.CommonModule,
                            paginator.MatPaginatorModule,
                            table.MatTableModule,
                            sort.MatSortModule,
                            card.MatCardModule,
                            formField.MatFormFieldModule,
                            router.RouterModule,
                        ],
                        exports: [
                            TableRowColumnDirective,
                            TableContentComponent,
                            TableTitleComponent,
                            TableHeaderComponent,
                            TableLayoutComponent,
                            TableContentResponsiveComponent
                        ]
                    },] }
        ];
        return TableLayoutModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LayoutModule = /** @class */ (function () {
        function LayoutModule() {
        }
        LayoutModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [LayoutComponent],
                        imports: [
                            TableLayoutModule
                        ],
                        exports: [
                            TableLayoutModule
                        ]
                    },] }
        ];
        return LayoutModule;
    }());

    exports.LayoutModule = LayoutModule;
    exports.ɵa = LayoutComponent;
    exports.ɵb = TableLayoutModule;
    exports.ɵc = TableRowColumnDirective;
    exports.ɵd = TableContentComponent;
    exports.ɵe = TableTitleComponent;
    exports.ɵf = TableHeaderComponent;
    exports.ɵg = TableLayoutComponent;
    exports.ɵh = TableContentResponsiveComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-base-angular-layout.umd.js.map
